/*  Copyright 1993-2011 EIAS3D, This Source code may be included in plug-ins, 
shaders, and utilities intended for use with the Electric Image Animation System.
This copyright notice must be included in its original form in all such products. 
This  source code may not be offered for sale or distributed by any entity 
without the express permission of EIAS3D.*/

#ifndef COLORMESH_HPP
#define COLORMESH_HPP

#include "System.h"
#include "Matrix.h"
#include "EI_Dialog.h"
#include "StreamEI.hpp"

#define SIGN_CMESH		'CMSH'
#define VERS_CMESH		0x0001

struct CCustomSaver {
	CCustomSaver( void ) { Init(); }
   ~CCustomSaver( void ) { Destroy(); }
	
	void Init   ( void );
	bool Alloc  ( UInt32 size );
	void Destroy( void );
	bool HasData( void ) const;
	
	bool Read   ( CStream & src );
	bool Write  ( CStream & dst ) const;

// data members
	void * mData;
	UInt32  mSize;
};

struct CColorMesh {
	CColorMesh( void )	{ Init(); }
	
	void Init ( void );
	
	bool Read ( CStream & src );
	bool Write( CStream & dst ) const;

	void	SaveSelf ( void );
	SInt32	AddVertex( float x, float y, const ARGB_Real & color );
	void	Generate ( void );

	void SetData( EI_Dialog * );
	void GetData( EI_Dialog * );
	
	static CColorMesh * ReadControlData( void );
	
// data members
	UInt32	mSign, mVers;
	SInt32	mStepX, mInterp;
	float	mScaleX, mScaleY;
	
	Matrix4 mGroupMatrix, mGroupRotMatrix, mGroupBlurMatrix;
	
	CCustomSaver mSavedGraph;
	CCustomSaver mSavedGradient;
};

#endif	// COLORMESH_HPP