/*  Copyright 1993-2011 EIAS3D, This Source code may be included in plug-ins, 
shaders, and utilities intended for use with the Electric Image Animation System.
This copyright notice must be included in its original form in all such products. 
This  source code may not be offered for sale or distributed by any entity 
without the express permission of EIAS3D.*/

#ifndef		EI_DIALOG_H
#define		EI_DIALOG_H

#ifndef		EI_TYPES_H
#include	"EI_Types.h"
#endif

#ifdef		__cplusplus
extern "C" {
#endif

EI_Dialog *EI_MakeDialog(EI_ResourceFile *iResourceFile,
							int iDialogID);
void EI_DestroyDialog(EI_Dialog *iDialog);

void EI_SetDialogTitle(EI_Dialog *ioDialog,
						const char *iTitleString);

void EI_MoveDialog(EI_Dialog *iDialog,
					int iNewLeft,
					int iNewTop);
void EI_GetDialogPosition(const EI_Dialog *iDialog,
							int *oLeft,
							int *oTop);

void EI_GetDialogSize(const EI_Dialog *iDialog,
						int *oWidth,
						int *oHeight);
void EI_SetDialogSize(EI_Dialog *iDialog,
						int iWidth,
						int iHeight);

void *EI_GetDialogExtraData(const EI_Dialog *iDialog);
void EI_SetDialogExtraData(EI_Dialog *ioDialog,
							void *iExtraData);

int EI_ExecuteDialog(EI_Dialog *iDialog);

void EI_ShowDialogModeless(EI_Dialog *iDialog);

void EI_HideDialogModeless(EI_Dialog *iDialog);

void EI_StopDialog(EI_Dialog *iDialog,
					int iResult);

void EI_SetDialogHitFunction(EI_Dialog *ioDialog,
								EI_DialogHitFunction iFunction);

void EI_SetDialogKeyFilterFunction(EI_Dialog *ioDialog,
									EI_DialogKeyFilter iFunction);

void EI_SetDialogValidateFunction(EI_Dialog *ioDialog,
									EI_DialogValidationFunction iFunction);

void EI_GetMonitorBounds(EI_Rect *oMonitorBounds);

void EI_GetDialogFrameOffset(const EI_Dialog *iDialog,
								int *oOffsetX,
								int *oOffsetY);

#ifdef		__cplusplus
}
#endif

#endif
