/*  Copyright 1993-2011 EIAS3D, This Source code may be included in plug-ins, 
shaders, and utilities intended for use with the Electric Image Animation System.
This copyright notice must be included in its original form in all such products. 
This  source code may not be offered for sale or distributed by any entity 
without the express permission of EIAS3D.*/

#ifndef		EI_TIMER_H
#define		EI_TIMER_H

#ifndef		EI_TYPES_H
#include	"EI_Types.h"
#endif

#ifdef		__cplusplus
extern "C" {
#endif

EI_Timer *EI_MakeTimer(void);
void EI_DestroyTimer(EI_Timer *iTimer);

void EI_SetTimerFunction(EI_Timer *ioTimer,
							EI_TimerFunction iFunction);

void EI_SetTimerExtraData(EI_Timer *ioTimer,
							void *iExtraData);
void *EI_GetTimerExtraData(const EI_Timer *iTimer);

int EI_StartPeriodicTimer(EI_Timer *iTimer,
							int iMilliseconds);
int EI_StartOneShotTimer(EI_Timer *iTimer,
							int iMilliseconds);
int EI_StopTimer(EI_Timer *iTimer);

#ifdef		__cplusplus
}
#endif

#endif
