/*  Copyright 1993-2011 EIAS3D, This Source code may be included in plug-ins, 
shaders, and utilities intended for use with the Electric Image Animation System.
This copyright notice must be included in its original form in all such products. 
This  source code may not be offered for sale or distributed by any entity 
without the express permission of EIAS3D.*/

#ifndef __MemoryUtils_h__
#define __MemoryUtils_h__

#ifndef _STRING_H
#include <string.h>
#endif

#ifndef __System_h__
#include "System.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* Memory copying routines */

#define CopyMem(sourcePtr, destPtr, byteCount)	memcpy(destPtr, sourcePtr, byteCount)

void CopySmallBlockForwards(void* sourcePtr, void* destPtr, UInt32 byteCount);
void CopySmallBlockBackwards(void* sourcePtr, void* destPtr, UInt32 byteCount);

/* PowerPC specific routines */

#if powerc
UInt32 GetCR(void);
void SetCR(UInt32 value);
UInt32 GetMSR(void);
void SetMSR(UInt32 value);
void ZeroCache(void* startNum, UInt32 count, UInt32 size);	/* Clears 32 byte cache blocks */
void TouchCache(void* startNum, UInt32 count, UInt32 size);	/* Touches 32 byte cache blocks */
void TouchSCache(void* startNum, UInt32 count, UInt32 size);	/* Touches for store 32 byte cache blocks */
void FlushCache(void* startNum, UInt32 count, UInt32 size);	/* Flushes 32 byte cache blocks */
#endif

/* Memory initialization routines */

void ZeroMem(void* startNum, UInt32 rangeNum);
void FillMem(void* startNum, UInt32 rangeNum, UInt32 valueNum);

#ifdef __cplusplus
}
#endif

#endif
