/*  Copyright 1993-2011 EIAS3D, This Source code may be included in plug-ins, 
shaders, and utilities intended for use with the Electric Image Animation System.
This copyright notice must be included in its original form in all such products. 
This  source code may not be offered for sale or distributed by any entity 
without the express permission of EIAS3D.*/

#ifndef __PlatformTypes_h__
#define __PlatformTypes_h__

/*
 *		User settable #defines
 *
 *		OS Selection:
 *		define __MACINTOSH__ if running under the Macintsoh OS
 *		define __WIN32__ if running on Windows 32 biys
 *		define __WIN64__ if running on Windows 64 bits
 *
 *		Basic 32/64 (unsigned) long types
*/


#ifdef __MACINTOSH__
	#if defined (_WIN32) || defined(_WIN64)
		#error "Invalid OS Selection"
	#endif
	
	typedef signed long	slong;
	typedef unsigned long	ulong;
#endif	// __MACINTOSH__

#ifdef __WIN32__
	#ifndef _WIN32
		#error "Invalid OS Selection"
	#endif
	
	typedef signed long		SInt32;
	typedef unsigned long	UInt32;
	typedef signed long		slong;
	typedef unsigned long	ulong;
#endif	// __WIN32__

#ifdef __WIN64__
	#ifndef _WIN64
		#error "Invalid OS Selection"
	#endif

	typedef signed long			SInt32;
	typedef unsigned long		UInt32;

	#define __LP64__			1
	typedef signed __int64		slong;
	typedef unsigned __int64	ulong;
#endif	// __WIN64__

#if __LP64__
	#define MASK_FFFFFFFC		0xFFFFFFFFFFFFFFFCLL
	#define MASK_FFFFFFFE		0xFFFFFFFFFFFFFFFELL
	#define MASK_FFFFFFFF		0xFFFFFFFFFFFFFFFFLL
#else
	#define MASK_FFFFFFFC		0xFFFFFFFC
	#define MASK_FFFFFFFE		0xFFFFFFFE
	#define MASK_FFFFFFFF		0xFFFFFFFF
#endif

#endif	// __PlatformTypes_h__
