/*  Copyright 1993-2011 EIAS3D, This Source code may be included in plug-ins, 
shaders, and utilities intended for use with the Electric Image Animation System.
This copyright notice must be included in its original form in all such products. 
This  source code may not be offered for sale or distributed by any entity 
without the express permission of EIAS3D.*/

#ifndef __FPU_h__
#define __FPU_h__

#ifndef __System_h__
#include "System.h"
#endif

#include <math.h>

#ifndef PI
 #define PI				3.14159265358979323846
#endif 
#define PI05			1.570796326794896619			/* 0.5 * pi */
#define PI15			4.712388980384689858			/* 1.5 * pi */
#define PI2				6.283185307179586478			/* 2.0 * pi */
#define PINeg		   	-3.14159265358979323846			/* -pi */
#define PINeg05			-1.570796326794896619			/* -0.5 * pi */
#define PINeg15			-4.712388980384689858			/* -1.5 * pi */
#define PINeg2			-6.283185307179586478			/* -2.0 * pi */
#define PIFac			0.0174532925199432957			/* pi / 180 */

#define SIN	sin
#define COS	cos
#define SQRT sqrt
#define TAN	tan
#define ATAN atan
#define ATAN2 atan2
#define ASIN asin
#define ACOS acos
#define SINH sinh
#define COSH cosh
#define TANH tanh
#define EXP exp
#define LOG log
#define LOG10 log10
#define POW(x, y) EXP((y) * LOG(x))

/* 8, 10, 12 Byte Floating Point Conversions */

void ConvertFloat12To10(void* the12, void* the10);
void ConvertFloat12To8(void* the12, void* the8);
void ConvertFloat10To12(void* the10, void* the12);
void ConvertFloat10To8(void* the10, void* the8);
void ConvertFloat8To10(void* the8, void* the10);
void ConvertFloat8To12(void* the8, void* the12);

#endif
