/*  Copyright 1993-2011 EIAS3D, This Source code may be included in plug-ins, 
shaders, and utilities intended for use with the Electric Image Animation System.
This copyright notice must be included in its original form in all such products. 
This  source code may not be offered for sale or distributed by any entity 
without the express permission of EIAS3D.*/

#ifndef __PluginMatrix_h__
#define __PluginMatrix_h__

#ifndef __FACTStuff_h__
#include "FACTStuff.h"
#endif

#ifndef __System_h__
#include "System.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define CopyMatrix4To4(dst, src) {\
	(dst)->m.m00 = (src)->m.m00;\
	(dst)->m.m01 = (src)->m.m01;\
	(dst)->m.m02 = (src)->m.m02;\
	(dst)->m.m03 = (src)->m.m03;\
	(dst)->m.m10 = (src)->m.m10;\
	(dst)->m.m11 = (src)->m.m11;\
	(dst)->m.m12 = (src)->m.m12;\
	(dst)->m.m13 = (src)->m.m13;\
	(dst)->m.m20 = (src)->m.m20;\
	(dst)->m.m21 = (src)->m.m21;\
	(dst)->m.m22 = (src)->m.m22;\
	(dst)->m.m23 = (src)->m.m23;\
	(dst)->m.m30 = (src)->m.m30;\
	(dst)->m.m31 = (src)->m.m31;\
	(dst)->m.m32 = (src)->m.m32;\
	(dst)->m.m33 = (src)->m.m33;\
}

/* Math Routines */

boolean Equal0(float n);
boolean Equal1(float n);
void Rot(double sinTheta, double cosTheta, double* n1, double* n2);

/* Matrix Routines */

void InvertMatrix4(Matrix4Ptr theMatrix, Matrix4 srcMatrix);
void TransposeMatrix4(Matrix4Ptr theMatrix, Matrix4 srcMatrix);
void AppendMatrix4(Matrix4Ptr theMatrix, Matrix4Ptr b);
void InsertMatrix4(Matrix4Ptr theMatrix, Matrix4Ptr a);
void NormalMatrix4(Matrix4Ptr theMatrix);
void TranslateMatrix4(Matrix4Ptr theMatrix, double tx, double ty, double tz);
void XRotateMatrix4(Matrix4Ptr theMatrix, double sinTheta, double cosTheta);
void YRotateMatrix4(Matrix4Ptr theMatrix, double sinTheta, double cosTheta);
void ZRotateMatrix4(Matrix4Ptr theMatrix, double sinTheta, double cosTheta);
void ScaleMatrix4(Matrix4Ptr theMatrix, double sx, double sy, double sz);
void TransformPoint(double* x, double* y, double* z, Matrix4Ptr theMatrix);
void TransformNormal(double* a, double* b, double* c, Matrix4Ptr theMatrix);
void TransformDCoordinate(DCoordPtr theCoordinate, Matrix4Ptr theMatrix);
#ifdef __cplusplus
}
#endif

#endif
