/*  Copyright 1993-2011 EIAS3D, This Source code may be included in plug-ins, 
shaders, and utilities intended for use with the Electric Image Animation System.
This copyright notice must be included in its original form in all such products. 
This  source code may not be offered for sale or distributed by any entity 
without the express permission of EIAS3D.*/

#include "MemoryUtils.h"

/* Memory copying routines */

void CopySmallBlockForwards(void* sourcePtr, void* destPtr, UInt32 byteCount)
{
	if (byteCount & 3) 
		if (byteCount & 1) {
			char *srcPtr = (char*)sourcePtr;
			char *dstPtr = (char*)destPtr;
			char *endPtr = srcPtr + byteCount;
			while (srcPtr != endPtr)
				*dstPtr++ = *srcPtr++;
		} else {
			short* srcPtr = (short*)sourcePtr;
			short* dstPtr = (short*)destPtr;
			short* endPtr = srcPtr + (byteCount >> 1);
			while (srcPtr != endPtr)
				*dstPtr++ = *srcPtr++;
		}
	else {
		UInt32* srcPtr = (UInt32*)sourcePtr;
		UInt32* dstPtr = (UInt32*)destPtr;
		UInt32* endPtr = srcPtr + (byteCount >> 2);
		while (srcPtr != endPtr)
			*dstPtr++ = *srcPtr++;
	}
}  /* CopySmallBlockForwards */

void CopySmallBlockBackwards(void* sourcePtr, void* destPtr, UInt32 byteCount)
{
	char *srcPtr = (char*)sourcePtr;
	char *dstPtr = (char*)destPtr + byteCount;
	char *endPtr = srcPtr + byteCount;
	while (srcPtr != endPtr)
		*--dstPtr = *srcPtr++;
}  /* CopySmallBlockBackwards */

/* Memory initialization routines */

void ZeroMem(void* startNum, UInt32 rangeNum)
{
	memset(startNum, 0, rangeNum << 2);
}  /* ZeroMem */

void FillMem(void* startNum, UInt32 rangeNum, UInt32 valueNum)
{
	UInt32 *thePtr = (UInt32*)startNum;
	UInt32 *endPtr = thePtr + rangeNum;
	
	while (thePtr != endPtr)
		*thePtr++ = valueNum;
}  /* FillMem */
