/*  Copyright 1993-2011 EIAS3D, This Source code may be included in plug-ins, 
shaders, and utilities intended for use with the Electric Image Animation System.
This copyright notice must be included in its original form in all such products. 
This  source code may not be offered for sale or distributed by any entity 
without the express permission of EIAS3D.*/

#include "System.h"

void ReverseField(void* theField, SInt32 size)
{
	char *start, *end;
	char temp;
	
	start = (char*)theField;
	end = start + size - 1;
	while (start < end) {
		temp = *start;
		*start = *end;
		*end = temp;
		start++;
		end--;
	}
}  /* ReverseField */

#ifdef __SGI__
UInt32 gTickCount = 0;
#endif

#ifndef __MACINTOSH__
#if !defined(__WIN32__) && !defined(__WIN64__)
#include <time.h>

/* Note: Don't use this function.  This is way slow */
SInt32 GetTick(void);
SInt32 GetTick(void)
{
	return clock() / (CLOCKS_PER_SEC / 60.0);
}  /* GetTick */

void GetDate(UInt32* secs);
void GetDate(UInt32* secs)
{
	*secs = (UInt32)time(nil);
}  /* GetDate */
#endif
#endif

short IAbs(short value)
{
	return (short)(value < 0 ? -value : value);
}  /* IAbs */

SInt32 LAbs(SInt32 value)
{
	return value < 0 ? -value : value;
}  /* LAbs */

float RAbs(float value)
{
	return value < 0.0 ? -value : value;
}  /* RAbs */

double DAbs(double value)
{
	return value < 0.0 ? -value : value;
}  /* DAbs */
